#!/pro/bin/perl -w

use strict;
use DB_File;

my %db;

my @attr = qw(name points country company certification responses
	      asigned answers rate bunny since quote lastc age
	      ptsitrc ptsbsf);
my %attr = map { $_ => 1 } @attr;

my (@id, @fields);
foreach my $arg (@ARGV) {
    exists $attr{$arg} ? push @fields, $arg : push @id, $arg;
    }

@fields or @fields = @attr;
for (@fields, "points") {
    tied %{$db{$_}} and next;	# No double tieing;
    tie %{$db{$_}}, "DB_File", "db/$_";
    }

@id && $id[0] eq "-a" and @id = sort keys %{$db{ptsitrc}};
@id or @id = ("BR41967");

for (@id) {
    s/^me$/BR41967/i;
    exists $db{points}{$_} or die "ID $_ not available";
    }

my $fmt = @id > 1 ? "%13s %s\t%s\n" : "DB attribute %-13s for %s is %s\n";

foreach my $field (@fields) {
    foreach my $id (@id) {
	my $value = $db{$field}{$id};
	$value = defined $value ? "'$value'" : "-- undef --";
	$value =~ m/^'(\d+)'$/ and $value = $1;

	printf $fmt, $field, $id, $value;
	}
    }
