#!/pro/bin/perl

use strict;
use warnings;

sub usage ()
{
    die "usage: itrc-speed [count (10000 runs) [delay (600 seconds) [start-time (now)]]]\n";
    } # usage

@ARGV == 1 and $ARGV[0] eq "-?" || $ARGV[0] =~ m/^-+help$/ and usage;

use Time::HiRes qw( gettimeofday tv_interval );

# http://forums2.itrc.hp.com/service/forums/publicProfile.do?userId=BR41967
# http://forums2.itrc.hp.com/service/forums/familyhome.do?familyId=117
my $id     = "BR41967";
my $id_url = "/service/forums/publicProfile.do?userId=BR41967";
my $ux_url = "/service/forums/familyhome.do?familyId=117";

$::opt_v   = $::opt_v   =  -1;
$::timeout = $::timeout = 900;
require "webget.pl";

my ($runs, $delay, $start) = (10000, 600);
@ARGV and $ARGV[0] =~ m/^\d+$/ and $runs  = shift;
@ARGV and $ARGV[0] =~ m/^\d+$/ and $delay = shift;
if (@ARGV and $ARGV[0] =~ m/^(\d+):(\d+)$/) {
    my @dt;
    do {
	@dt = localtime;
	} while ($dt[2] < $1 || $dt[1] < $2 and sleep 1);
    }

$| = 1;
local $/;
while ($runs--) {
    my @dt = localtime;
    printf "%04d-%02d-%02d %02d:%02d:%02d ",
	$dt[5] + 1900, $dt[4] + 1, $dt[3], $dt[2], $dt[1], $dt[0];

    my $t0 = [ gettimeofday ];

    my $page = webget ($ux_url, "-");
    if (index $page, "<title>IT Resource Center forums - hp-ux</title>") {
	my $l0 = length $page;
	my $elapsed = tv_interval ($t0);
	printf "%6d %6.2f s %6.2f kbps", $l0, $elapsed, $l0 / 1024 / $elapsed;
	}
    } continue {
	print "\n";
	$runs and sleep $delay;
	}
