#!/pro/bin/perl -w

# quotes.pl generates quotes.html and quotes.txt

use strict;
use DB_File;

my %db;

my @attr = qw(name points quote);
tie my %n, "DB_File", "db/name";
tie my %q, "DB_File", "db/quote";

my @id = sort keys %n;

open HTML, "> quotes.html";
open TXT,  "> quotes.txt";

print HTML <<HDR;
<html>
<head>
  <title>ITRC Forum quotes 16 July 2003</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
  <meta name="Generator" content="perl-5.8.0">
  <meta name="Author"    content="H.Merijn Brand - BR41967 - procura">
  <style type="text/css">
    body { font-family: Helvetica, sans-serif }
    pre  { font-family: LettrGothic12BT, Lucida console }
    </style>
  </head>
<body>
<table>
HDR

foreach my $id (@id) {
    exists $q{$id} && length ($q{$id}) > 1 or next;
    print HTML qq{<tr><td><a href="http://forums.itrc.hp.com/cm/UserProfile/1,,$id!1,00.html">$n{$id}</a></td><td>$q{$id}</td></tr>\n};
    printf TXT "%-8.8s %-20.20s %s\n", $id, $n{$id}, $q{$id};
    }
print HTML "</table>\n</body>\n</html>\n";

close HTML;
close TXT;
