#!/pro/bin/perl -w

use strict;
use Getopt::Long qw(:config bundling nopermute);
my $opt_n = 0;
my $opt_s = 0;
GetOptions (
    "s|strings"	=> \$opt_s,
    "n|numbers"	=> \$opt_n,
    ) or die "usage: $0 [ -n ] [ -s ]\n";
$opt_n || $opt_s or $opt_n = $opt_s  = 1;

use DB_File;

tie my %points, "DB_File", "db/points",  O_RDONLY;
my @id = sort keys %points;
untie %points;

if ($opt_n) {
    foreach my $attr (qw( points ptsitrc ptsbsf bunny since lastc
			  responses asigned answers )) {
	print "Rebuilding $attr ...\n";
	my (%s, %x);
	tie %s, "DB_File", "db/$attr",  O_RDONLY;
	foreach my $id (@id) {
	    exists $s{$id} && defined $s{$id} or $s{$id} = 0;
	    $x{$id} = 0 + $s{$id};
	    }
	untie %s;
	unlink "db/$attr";
	tie %s, "DB_File", "db/$attr",  O_CREAT|O_RDWR, 0666, $DB_HASH;
	foreach my $id (sort keys %x) {
	    $s{$id} = $x{$id};
	    }
	untie %s;
	}
    }

if ($opt_s) {
    foreach my $attr (qw( country name rate certification company quote )) {
	print "Rebuilding $attr ...\n";
	my (%s, %x);
	tie %s, "DB_File", "db/$attr",  O_RDONLY;
	foreach my $id (@id) {
	    exists $s{$id} && defined $s{$id} or $s{$id} = "";
	    ($x{$id} = $s{$id}) =~ s/\s+$//;
	    $x{$id} eq "Usa" and $x{$id} = "USA";
	    $x{$id} eq "Uk"  and $x{$id} = "UK";
	    $x{$id} eq "Uae" and $x{$id} = "UAE";
	    }
	untie %s;
	unlink "db/$attr";
	tie %s, "DB_File", "db/$attr",  O_CREAT|O_RDWR, 0666, $DB_HASH;
	foreach my $id (sort keys %x) {
	    $s{$id} = $x{$id};
	    }
	untie %s;
	}
    }
