#!/pro/bin/perl -w

use strict;
use DB_File;

my %db;

my @attr = qw(name points country company certification responses
	      asigned answers rate bunny since quote lastc age
	      ptsitrc ptsbsf );
my %attr = map { $_ => 1 } @attr;

my (@val, @fields);
foreach my $arg (@ARGV) {
    exists $attr{$arg} ? push @fields, $arg : push @val, qr/$arg/i;
    }

@fields or @fields = @attr;
for (@fields, "points") {
    tied %{$db{$_}} and next;	# No double tieing;
    tie %{$db{$_}}, "DB_File", "db/$_";
    }

my @id = sort keys %{$db{points}};
@val or @val = (qr/^/);

my $fmt = @id > 1 ? "%13s %s\t%s\n" : "DB attribute %-13s for %s is %s\n";

print STDERR "Search for (@val) in ", scalar @id, " @fields\'s\n";
foreach my $field (@fields) {
    foreach my $id (@id) {
	my $value = $db{$field}{$id};
	$value = defined $value ? "'$value'" : "-- undef --";
	$value =~ m/^'(\d+)'$/ and $value = $1;
	for my $pat (@val) {
	    $value =~ $pat or next;
	    printf $fmt, $field, $id, $value;
	    last;
	    }
	}
    }
